services:
  - docker:dind

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2

build-server:
  image: maven:3-jdk-8
  stage: build
  script:
    - mvn clean install
  artifacts:
    paths:
      - ./tm-server/target/*.jar

build-client:
  image: maven:3-jdk-8
  stage: build
  script:
    - mvn clean install
  artifacts:
    paths:
      - ./tm-client/target/*.jar

build-logger:
  image: maven:3-jdk-8
  stage: build
  script:
    - mvn clean install
  artifacts:
    paths:
      - ./tm-logger/target/*.jar

publish-server:
  image: docker:19.03.0
  stage: deploy
  script:
     - docker build -f ./tm-server/Dockerfile -t registry.gitlab.com/irkka.hiiri/tsc-java-51/tm-server:latest .
     - docker login -u irkka.hiiri -p v3A3vSmAx_hstyYYbZnQ registry.gitlab.com
     - docker push registry.gitlab.com/irkka.hiiri/tsc-java-51/tm-server:latest
  only:
    - master
  dependencies:
    - build-server

publish-client:
  image: docker:19.03.0
  stage: deploy
  script:
     - docker build -f ./tm-client/Dockerfile -t registry.gitlab.com/irkka.hiiri/tsc-java-51/tm-client:latest .
     - docker login -u irkka.hiiri -p v3A3vSmAx_hstyYYbZnQ registry.gitlab.com
     - docker push registry.gitlab.com/irkka.hiiri/tsc-java-51/tm-client:latest
  only:
    - master
  dependencies:
    - build-client

publish-logger:
  image: docker:19.03.0
  stage: deploy
  script:
     - docker build -f ./tm-logger/Dockerfile -t registry.gitlab.com/irkka.hiiri/tsc-java-51/tm-logger:latest .
     - docker login -u irkka.hiiri -p v3A3vSmAx_hstyYYbZnQ registry.gitlab.com
     - docker push registry.gitlab.com/irkka.hiiri/tsc-java-51/tm-logger:latest
  only:
    - master
  dependencies:
    - build-logger
